import { MigrationInterface, QueryRunner } from "typeorm";
import {
  inspection_plan_table,
  inspection_versioned_plan_table,
  inspection_point_table,
  inspection_table,
  inspection_point_result_table,
} from "./baseSchemaTables/inspection";
import {
  equipment_type_table,
  equipment_table,
  vehicle_type_table,
  vehicle_table,
  wearable_type_table,
  wearable_table,
} from "./baseSchemaTables/unit";
import { maintenance_table, damage_report_table } from "./baseSchemaTables/unit_extend";

export class UnitBase1749361405703 implements MigrationInterface {
  name = "UnitBase1749361405703";

  public async up(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.createTable(equipment_type_table, true, true, true);
    await queryRunner.createTable(equipment_table, true, true, true);
    await queryRunner.createTable(vehicle_type_table, true, true, true);
    await queryRunner.createTable(vehicle_table, true, true, true);
    await queryRunner.createTable(wearable_type_table, true, true, true);
    await queryRunner.createTable(wearable_table, true, true, true);

    await queryRunner.createTable(maintenance_table, true, true, true);
    await queryRunner.createTable(damage_report_table, true, true, true);

    await queryRunner.createTable(inspection_plan_table, true, true, true);
    await queryRunner.createTable(inspection_versioned_plan_table, true, true, true);
    await queryRunner.createTable(inspection_point_table, true, true, true);

    await queryRunner.createTable(inspection_table, true, true, true);
    await queryRunner.createTable(inspection_point_result_table, true, true, true);
  }

  public async down(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.dropTable(inspection_point_result_table, true, true, true);
    await queryRunner.dropTable(inspection_table, true, true, true);

    await queryRunner.dropTable(inspection_point_table, true, true, true);
    await queryRunner.dropTable(inspection_versioned_plan_table, true, true, true);
    await queryRunner.dropTable(inspection_plan_table, true, true, true);

    await queryRunner.dropTable(damage_report_table, true, true, true);
    await queryRunner.dropTable(maintenance_table, true, true, true);

    await queryRunner.dropTable(wearable_table, true, true, true);
    await queryRunner.dropTable(wearable_type_table, true, true, true);
    await queryRunner.dropTable(vehicle_table, true, true, true);
    await queryRunner.dropTable(vehicle_type_table, true, true, true);
    await queryRunner.dropTable(equipment_table, true, true, true);
    await queryRunner.dropTable(equipment_type_table, true, true, true);
  }
}
